<script>
import { required, maxLength } from 'vuelidate/lib/validators';
import VueGoogleAutocomplete from 'vue-google-autocomplete';
import { outletService } from '../../services'
import { error_message, success_message } from '../../Helper/helper';
export default {
    components: { VueGoogleAutocomplete },
    data() {
        return {
            cuisines: [],
            selectedCuisines: [],
            restaurantCuisines: [],
            cuisineImg: "../../../../images/thaicuisine.png"
        }
    },
    mounted() {
        this.getRestaurantCuisines()
    },
    validations: {},
    methods: {
        getRestaurantCuisines() {
            outletService.getRestaurantCuisines().then((response) => {
                if (response.data.code == 200) {
                    this.cuisines = response.data.result.cuisines
                    this.selectedCuisines = response.data.result.selectedcuisines
                    this.selectedCuisines.forEach(element => {
                        this.restaurantCuisines.push(element.cuisine_id);
                    });

                } else {
                    error_message(response.data.message)
                }
            })
        },
        addCuisines(id) {
            if (this.restaurantCuisines.indexOf(id) == -1) {
                this.restaurantCuisines.push(id)
            } else {
                var index = this.restaurantCuisines.indexOf(id);
                this.restaurantCuisines.splice(index, 1)
            }
        },
        submitCuisines() {
            outletService.updatedRestaurantCuisines({ data: JSON.stringify(this.restaurantCuisines) }).then((response) => {
                if (response.data.code == 200) {
                    this.$emit('actionChanged', 2);
                    success_message(response.data.message)
                } else {
                    error_message(response.data.message)
                }
            })
        }
    }
}
</script>
<template>    
    <div class="row">
        <div class="cuisions-grid">
        <template v-for="cuisine in cuisines">
                <div class="position-relative">
                    <div class="cuisions-right" v-if="restaurantCuisines.includes(cuisine.id)">
                        <i class="bx bx-check"></i>
                    </div>
                    <img :src="cuisineImg" alt="cuisions" class="cu-img"/>
                    <div class="box position-absolute new-cuisions" @click="addCuisines(cuisine.id)" :class="{ 'bg-active': restaurantCuisines.includes(cuisine.id), 'bg-inactive': !restaurantCuisines.includes(cuisine.id) }">
                        <p class="m-0"> {{ cuisine.cuisine_name }}</p>
                    </div>
                </div>
            </template>        
        </div>
        <div class="col-md-12 mt-4 text-center">
            <button class="btn btn-primary" @click="$emit('actionChanged', 0)">{{ trans.get('__JSON__.Previous') }}</button>
            <button class="btn btn-primary" @click="submitCuisines">{{ trans.get('__JSON__.Save') }}</button>
        </div>
    </div>    
</template>


<style scoped>
.box {
    cursor: pointer;
    display: flex;
    padding: 5px;
    align-items: center;
    justify-content: center;
    flex-direction: column-reverse;
    flex-wrap: nowrap;
    /* background-color: #d4d4d4ab; */
    border-radius: 6px;
    height: 100px;
    font-size: 20px;
    color: black;
    font-weight: 500;
}

.bg-inactive {
    background-color: #d4d4d4ab;
}

.bg-active {
    background-color: #a5a1a1;
    color: white;
}

.bg-button {
    background-color: #000000a6;
    color: white;
}
img.cu-img {
    width: 100%;
    height: 250px;
    object-fit: cover;
    object-position: top;
    border-radius: 6px;
}

.new-cuisions {
    width: 100%;
    bottom: 0;
    display: flex;
    align-items: center;
    justify-content: center;
    padding: 15px;
    height: auto;
    color: white;
    background: rgba(0, 0, 0, 0.5);
}

.bg-active {
    background: #556ee6;
    color: white;
}

.cuisions-right {
    background: #556ee6;
    border-radius: 100%;
    width: 25px;
    height: 25px;
    display: flex;
    align-items: center;
    justify-content: center;
    color: white;
    position: absolute;
    right: -5px;
    top: -5px;
}

.cuisions-grid {
    display: grid;
    grid-template-columns: repeat(5, 1fr);
    gap: 25px;
}

/* .box:hover{
    box-shadow: 6px 6px 6px 0px #1a1919d1;
} */
</style>